#ifndef BATTERYWIDGET_H
#define BATTERYWIDGET_H

#include <QObject>
#include <QWidget>
#include <QLabel>
#include <QDBusInterface>
#include <QPushButton>
#include <QPoint>
#include "enginedevice.h"

#define FREEDESKTOP_UPOWER                  "org.freedesktop.DBus.Properties"
#define UPOWER_INTERFACE                    "org.freedesktop.UPower"
#define UPOWER_PATH                         "/org/freedesktop/UPower"
#define UPOWER_SERVICE                      "org.freedesktop.UPower"
#define UPOWER_DISPLAY_PATH                 "/org/freedesktop/UPower/devices/DisplayDevice"
#define UPOWER_DIVICES_SERVICE              "org.freedesktop.UPower.Device"

class BatteryWidget : public QWidget
{
    Q_OBJECT
public:
    BatteryWidget(QPoint point, QWidget *parent = nullptr);

    void initUi();
    void setupComponent();
    void setPoint(QPoint point);
    QString getBatteryIconName();

protected:
    void showEvent(QShowEvent *event);
    void paintEvent(QPaintEvent *event);

private:
    QLabel *mModeLabel;
    QPushButton *mIconBtn;
    QLabel *mValueLabel;
    QLabel *mStatusLabel;
    QPoint mPoint;

    QDBusInterface *batInterface;
    QDBusInterface *iface;

    EngineDevice* ed;

private Q_SLOTS:
    void setBatteryIcon(QString icon);
    void onBatteryChanged(QStringList args);
    void dealMessage(QDBusMessage);

};

#endif // BATTERYWIDGET_H
